commit d974be78384cfaee2e58a8edf75704a3d0d1b013
Author: freddy77 <freddy77>
Date:   Wed May 27 17:58:02 2009 +0000

    fix test for MS ODBC

diff --git a/ChangeLog b/ChangeLog
index c267c8d..e0ba2fe 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Wed May 27 19:57:53 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/genparams.c: fix for MS ODBC
+
 Tue May 26 18:18:50 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/query.c: reduce num scope
 
@@ -1579,4 +1582,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2797 2009/05/26 16:20:32 freddy77 Exp $
+$Id: ChangeLog,v 1.2798 2009/05/27 17:58:02 freddy77 Exp $
diff --git a/src/odbc/unittests/genparams.c b/src/odbc/unittests/genparams.c
index acb7ecb..8411ed6 100644
--- a/src/odbc/unittests/genparams.c
+++ b/src/odbc/unittests/genparams.c
@@ -18,7 +18,7 @@
  * Also we have to check normal char and wide char
  */
 
-static char software_version[] = "$Id: genparams.c,v 1.42 2009/03/17 09:05:47 freddy77 Exp $";
+static char software_version[] = "$Id: genparams.c,v 1.43 2009/05/27 17:58:02 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #ifdef TDS_NO_DM
@@ -79,6 +79,13 @@ TestOutput(const char *type, const char *value_to_convert, SQLSMALLINT out_c_typ
 		CHKExecute("S");
 	}
 
+	/*
+	 * MS OBDC requires it cause first recordset is a recordset with a
+	 * warning caused by the way it execute RPC (via EXEC statement)
+	 */
+	if (use_cursors && !driver_is_freetds())
+		SQLMoreResults(Statement);
+
 	/* test results */
 	sbuf[0] = 0;
 	switch (out_c_type) {
@@ -297,7 +304,9 @@ AllTests(void)
 		TestOutput("VARCHAR(20)", "313233", SQL_C_BINARY, SQL_VARCHAR, "313233");
 	/* FIXME our driver ignore precision for date */
 	precision = 3;
-	TestOutput("DATETIME", "2004-02-24 15:16:17", SQL_C_BINARY, SQL_TIMESTAMP, big_endian ? "0000949700FBAA2C" : "979400002CAAFB00");
+	/* Some MS driver incorrectly prepare with smalldatetime*/
+	if (!use_cursors || driver_is_freetds())
+		TestOutput("DATETIME", "2004-02-24 15:16:17", SQL_C_BINARY, SQL_TIMESTAMP, big_endian ? "0000949700FBAA2C" : "979400002CAAFB00");
 	TestOutput("SMALLDATETIME", "2004-02-24 15:16:17", SQL_C_BINARY, SQL_TIMESTAMP,
 	     big_endian ? "0000949700FB9640" : "979400004096FB00");
 	TestInput(SQL_C_TYPE_TIMESTAMP, "DATETIME", SQL_TYPE_TIMESTAMP, "DATETIME", "2005-07-22 09:51:34");

